
function Interface
fidtotal = fopen('inputdata.txt','w');
fclose(fidtotal);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%      BEGIN of the interface for the number of beliefs      %%%%%%%%%
fh = figure(10);
set(fh,'Visible','on','Name','Valuation-Based System', 'color', [0.941,0.941,0.941], 'Resize', 'off', ...
            'Position',[260,200,400,320]);
        
text1 = uicontrol(fh,'Style','text', ...
                'String','Insert the number of the beliefs',...
                'Position',[12 290 200 20]);
    
EditTest1 = uicontrol(fh,'Style','edit', 'BackgroundColor', 'white', ...
                'String','',...
                'Position',[220 293 50 20]);
            
OkButton1 = uicontrol(fh,'Style','pushbutton','String','OK',...
                'Position',[300 293 30 20], 'Callback', @OkButton1_Callback); 
%%%%%%      END of the interface for the number of beliefs      %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%      BEGIN of the interface for Belief      %%%%%%%%%%%%%%%%%%%%%%%%          
            
PanelBelief1 = uipanel('Title','Belief #1',...
                'Position',[.05 .16 .9 .75]);

%%%%%%      BEGIN of the interface for Belief or Rule?      %%%%%%%%%%%%%%%          
ChoiceButton = uibuttongroup('Parent',fh,'Title','Belief or Rule?',...
            'Position',[.15 .69 .7 .15], 'SelectionChangeFcn', @ChoiceButton_SelectionChangeFcn);       
         
RadioBelief = uicontrol(ChoiceButton,'Style','radiobutton', ...
                'String','Joint belief',...
                'Tag', 'RadioBelief',...
                'Value',1,'Position',[20 10 70 20]);
            
RadioRule = uicontrol(ChoiceButton,'Style','radiobutton', ...
                'String','Joint rule',...
                'Tag', 'RadioRule',...
                'Value',0,'Position',[120 10 70 20]);
            
OkButton2 = uicontrol(ChoiceButton,'Style','pushbutton','String','OK',...
                'Position',[220 10 30 20], 'Callback', @OkButton2_Callback);
%%%%%%      END of the interface for Belief or Rule?      %%%%%%%%%%%%%%%%%
%%%%%%      BEGIN of the interface for Belief      %%%%%%%%%%%%%%%%%%%%%%%%                
text2 = uicontrol(fh,'Style','text', ...
                'String','Insert variables',...
                'Position',[66 180 80 20]);
            
EditTest2 = uicontrol(fh,'Style','edit', 'BackgroundColor', 'white', ...
                'String','',...
                'Position',[190 183 50 20]);            

text3 = uicontrol(fh,'Style','text', ...
                'String','Insert num focal sets',...
                'Position',[65 155 110 20]);  
            
EditTest3 = uicontrol(fh,'Style','edit', 'BackgroundColor', 'white',...
                'String','',...
                'Position',[190 158 50 20]);      
            
OkButton3 = uicontrol(fh,'Style','pushbutton','String','OK',...
                'Position',[282 158 30 20], 'Callback', @OkButton3_Callback); 

PanelFocalSet1 = uipanel('Title',strcat('Focal set #1'),...
                'Position',[.15 .19 .7 .23]);   
            
%%%%%%      BEGIN of the interface for Belief: Focal set      %%%%%%%%%%%%%        
text4 = uicontrol(PanelFocalSet1,'Style','text', ...
                'String','Insert value',...
                'Position',[20 30 60 20]);
            
EditTest4 = uicontrol(PanelFocalSet1,'Style','edit', 'BackgroundColor', 'white', ...
                'String','',...
                'Position',[128 33 50 20]);            

text5 = uicontrol(PanelFocalSet1,'Style','text', ...
                'String','Insert mass',...
                'Position',[20 5 60 20]);  
            
EditTest5 = uicontrol(PanelFocalSet1,'Style','edit', 'BackgroundColor', 'white',...
                'String','',...
                'Position',[128 8 50 20]);      
            
OkButton4 = uicontrol(PanelFocalSet1,'Style','pushbutton','String','OK',...
                'Position',[220 8 30 20],  'Callback', @OkButton4_Callback);             
%%%%%%      END of the interface for Belief: Focal set      %%%%%%%%%%%%%%%   
%%%%%%      END of the interface for Belief      %%%%%%%%%%%%%%%%%%%%%%%%%% 
%%%%%%      BEGIN of the interface for Rule      %%%%%%%%%%%%%%%%%%%%%%%%%%
text6 = uicontrol(fh,'Style','text', ...
                'String','Antecedent variable',...
                'Visible','off',...
                'Position',[67 194 100 20]);
            
EditTest6 = uicontrol(fh,'Style','edit', 'BackgroundColor', 'white', ...
                'String','',...
                'Visible','off',...
                'Position',[190 197 50 20]);        
            
text7 = uicontrol(fh,'Style','text', ...
                'String','Value',...
                'Visible','off',...
                'Position',[250 194 30 20]);  
            
EditTest7 = uicontrol(fh,'Style','edit', 'BackgroundColor', 'white',...
                'String','',...
                'Visible','off',...
                'Position',[288 197 50 20]);   
            
text8 = uicontrol(fh,'Style','text', ...
                'String','Consequent variable',...
                'Visible','off',...
                'Position',[67 166 100 20]);  
            
EditTest8 = uicontrol(fh,'Style','edit', 'BackgroundColor', 'white',...
                'String','',...
                'Visible','off',...
                'Position',[190 169 50 20]); 
            
text9 = uicontrol(fh,'Style','text', ...
                'String','Insert num of conseq.',...
                'Visible','off',...
                'Position',[65 138 110 20]);  
            
EditTest9 = uicontrol(fh,'Style','edit', 'BackgroundColor', 'white',...
                'String','',...
                'Visible','off',...
                'Position',[190 141 50 20]); 
            
OkButton5 = uicontrol(fh,'Style','pushbutton','String','OK',...
                'Visible','off',...
                'Position',[282 141 30 20], 'Callback', @OkButton5_Callback);     
%%%%%%      End of the interface for Rule      %%%%%%%%%%%%%%%%%%%%%%%%%%%% 
            
%%%%%%      END of the interface for Belief      %%%%%%%%%%%%%%%%%%%%%%%%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


StartButton = uicontrol(fh,'Style','pushbutton',...
                'String','START',...
                'Position',[171 10 60 30], 'Callback', @StartButton_Callback);
            
    function ChoiceButton_SelectionChangeFcn(hObject, eventdata)
        switch get(eventdata.NewValue,'Tag')  
            case 'RadioBelief'
                %%%%  Make the interface of rule invisible  %%%%%%%%%%%%%%%
                set(text6,'Visible','off'); 
                set(EditTest6,'Visible','off'); 
                set(text7,'Visible','off'); 
                set(EditTest7,'Visible','off'); 
                set(text8,'Visible','off'); 
                set(EditTest8,'Visible','off'); 
                set(text9,'Visible','off'); 
                set(EditTest9,'Visible','off');
                set(OkButton5,'Visible','off');
                %%%%  Make the interface of belief visible  %%%%%%%%%%%%%%%
                set(text2,'Visible','on'); 
                set(EditTest2,'Visible','on'); 
                set(text3,'Visible','on'); 
                set(EditTest3,'Visible','on'); 
                set(OkButton3,'Visible','on');
        
                set(PanelFocalSet1, 'Title', 'Focal set #1');
            case 'RadioRule'
                %%%%  Make the interface of belief invisible  %%%%%%%%%%%%%
                set(text2,'Visible','off'); 
                set(EditTest2,'Visible','off'); 
                set(text3,'Visible','off'); 
                set(EditTest3,'Visible','off'); 
                set(OkButton3,'Visible','off');

                %%%%  Make the interface of rule visible  %%%%%%%%%%%%%%%%%
                set(text6,'Visible','on'); 
                set(EditTest6,'Visible','on'); 
                set(text7,'Visible','on'); 
                set(EditTest7,'Visible','on'); 
                set(text8,'Visible','on'); 
                set(EditTest8,'Visible','on'); 
                set(text9,'Visible','on'); 
                set(EditTest9,'Visible','on');
                set(OkButton5,'Visible','on');
        
                set(PanelFocalSet1, 'Title', 'Consequence #1');
        end
    end
                 
    %%%%%%%%%%%%  Callbacks for MYGUI
    function OkButton1_Callback(hObject, eventdata)
        fidtotal = fopen('inputdata.txt','a');
        fprintf(fidtotal, '%s\n', get(EditTest1, 'String'));
        fclose(fidtotal);
        
        NBeliefs = str2num(get(EditTest1, 'String'));
        for i=1:NBeliefs
            set(PanelBelief1,'Title',strcat('Belief #', num2str(i))); 
            uiwait;
        end
        
    end

    function OkButton2_Callback(hObject, eventdata)
        fidtotal = fopen('inputdata.txt','a');
        switch get(RadioBelief,'Value')  
            case 1
                fprintf(fidtotal, '1\n');
            case 0
                fprintf(fidtotal, '2\n');
        end
        fclose(fidtotal);
    end


    function OkButton3_Callback(hObject, eventdata)
        fidtotal = fopen('inputdata.txt','a');
        fprintf(fidtotal, '%s\n', get(EditTest2, 'String'));
        fprintf(fidtotal, '%s\n', get(EditTest3, 'String'));
        fclose(fidtotal);
        
        NFocalSets = str2num(get(EditTest3, 'String'));
        for i=1:NFocalSets
            set(PanelFocalSet1,'Title',strcat('Focal set #', num2str(i)));   
            uiwait;
        end
    end

    function OkButton4_Callback(hObject, eventdata)
        fidtotal = fopen('inputdata.txt','a');
        fprintf(fidtotal, '%s\n', get(EditTest4, 'String'));
        fprintf(fidtotal, '%s\n', get(EditTest5, 'String'));
        fclose(fidtotal);
        uiresume;
    end

    function OkButton5_Callback(hObject, eventdata)
        fidtotal = fopen('inputdata.txt','a');
        fprintf(fidtotal, '%s\n', get(EditTest6, 'String'));
        fprintf(fidtotal, '%s\n', get(EditTest7, 'String'));
        fprintf(fidtotal, '%s\n', get(EditTest8, 'String'));
        fprintf(fidtotal, '%s\n', get(EditTest9, 'String'));
        fclose(fidtotal);
        
        NConsequences = str2num(get(EditTest9, 'String'));
        for i=1:NConsequences
            set(PanelFocalSet1,'Title',strcat('Consequence #', num2str(i))); 
            uiwait;
        end
    end


    function StartButton_Callback(hObject, eventdata)
        %_______________________________________________________________________
        %CREATE MASSES AND RULES 
        %%define variables and frame
        [nf,F,nv,V]=SimpleExampleFrame;
        %%insert input beliefs
        [M,nm,rule,nir]=input_belief_new(F,V,'SimpleExample_mat',0);
        load SimpleExample_mat M nm rule nir
        %%insert time updating fot the beliefs
        %[Mi,nmi,rulei,niri]=input_belief(F,V,'time_updating_seq',1);
        save SimpleExample_mat nf F nv V nm M rule nir
        
        SimpleExample

    end

end


