
%             v: [1 2 3]
%            nv: 3
%      cartprod: [7 4 4]
%            ne: 112
%        matrix: [112x3 double]
%     num_focal: 1
%           foc: [1x1 struct]
% 1x7 struct array with fields:
%     num_el
%     elem
%     mass
function Mo=outward(BJT,M,nm,Nn,F,V,D)

root=BJT.root;

%Initialization
for i=1:nm
    Mo(i)=M(i);
    Mo(i).num_focal=0;
    Mo(i).foc=[];
    Mr(i)=M(i);
    Mr(i).num_focal=0;
    Mr(i).foc=[];
end
Mo(root)=M(root);
Mr(root).num_focal=1;
Mr(root).foc(1).num_el=Mr(root).ne;%vacuos belief
Mr(root).foc(1).elem=[1:Mr(root).ne];
Mr(root).foc(1).mass=1;
%
next=[];
for i=1:nm
    if i~=root
        if Mo(i).num_focal==0 & Mo(BJT.node(i).father).num_focal>0
            next=[next i];
        end
    end
end

while isempty(next)==0
    n=next(1);
    if BJT.node(BJT.node(n).father).lson==n;
        broth=BJT.node(BJT.node(n).father).rson;
    else
        broth=BJT.node(BJT.node(n).father).lson;
    end
    Mr(n)=val_prod(M(broth),Mr(BJT.node(n).father),[],F,V);
    delta=setdiff(Mr(n).v,M(n).v);
    Mr(n)=var_elim(n,Mr,delta,F,V);
    Mo(n)=val_prod(M(n),Mr(n),[],F,V);
    next=[];
    for i=1:nm
        if Mo(i).num_focal==0 & Mo(BJT.node(i).father).num_focal>0
            next=[next i];
        end
    end
end

