function visit_tree(T,codeV)

%visit_tree: visit and plot the BJT
%
%visit_tree(T,codeV)
%
%
%INPUT:
% T= BJT
% codeV: name of the nodes in the BJT

%visit T
Qq=[];
root=T.root;  %root node
Qq=[root Qq]; %Queque
%
Rq=0;
Snam(1).dom=T.node(root).dom; %info into nodes
Snam(1).num=root; %node noum
ni=1;
F=[root 1];
while size(Qq)>0
    %Extract a node from Qq
    node2=Qq(1);
    sq=size(Qq,2);
    Qq=Qq(:,2:sq);
    %[num2str(node2) '-(' num2str(T.node(node2).dom) ')']
    if T.node(node2).lson>0 %if the node has a left son
        Qq=[T.node(node2).lson Qq];
        ind=find(F(:,1)==T.node(T.node(node2).lson).father);
        Rq=[Rq F(ind,2) ];
        ni=ni+1;
        F=[F; [T.node(node2).lson ni]];
        Snam(ni).dom=T.node(T.node(node2).lson).dom;
        Snam(ni).num=T.node(node2).lson;
    end
    if T.node(node2).rson>0  %if the node has a right son
        Qq=[T.node(node2).rson Qq];
        ind=find(F(:,1)==T.node(T.node(node2).rson).father);
        Rq=[Rq F(ind,2) ];
        ni=ni+1;
        F=[F; [T.node(node2).rson ni]];
        Snam(ni).dom=T.node(T.node(node2).rson).dom;
        Snam(ni).num=T.node(node2).rson;
    end
end


% plot tree
figure
treeplot(Rq);

[x,y]=treelayout(Rq);
hold on 
ss=size(x,2);
for i=1:ss
%     strdom=char(codeV([Snam(i).dom(1)],:));
%     for j=2:length(Snam(i).dom)
%         strdom=[strdom; ['-' char(codeV([Snam(i).dom(j)],:))]];
%     end
    h=text(x(i)-0.018,y(i),num2str(Snam(i).num));
    h=text(x(i)+0.008,y(i)-0.012, char(codeV([Snam(i).dom],:)));
    set(h,'fontsize',10);
end
